//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
//
// vwPlayer
//
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// vwPlayer_SelectVideoOrVis
//
function vwPlayer_SelectVideoOrVis( fForce )
{
    if ( ( player.openState == 13 ) || ( fForce ) )
    {
        var vid = false;
        try
        {
            vid = (player.currentMedia.imageSourceWidth > 0) && (player.currentMedia.imageSourceHeight > 0);
        }
        catch(err){}
        
        if (vid)
        {
            svwVis.visible = false;
            svwVideo.visible = true;
        }
        else
        {
            SynchEffectColor();
            svwVis.visible = true;
            svwVideo.visible = false;
        }
    }
}

function SynchEffectColor()
{
    try
    {
        if (ctrlVis.currentEffectType=="Bars") 
        {
            if ( (ctrlVis.currentPreset==1) || (ctrlVis.currentPreset==2) )
            {
                //ignore Ocean Mist and Fire Storm
                return;
            }
            else
            {
                var bars = ctrlVis.currentEffect;
                bars.levelColor = mediacenter.itemPlayingColor;
                bars.peakColor  = mediacenter.appColorLight;
            }
        }
        else
        {
            //give all viz'es a chance to synch the color
            ctrlVis.currentEffect.foregroundColor = mediacenter.itemPlayingColor;
        }
    }
    catch(err){}
}



//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// vwPlayer_OnLoad
//
function vwPlayer_OnLoad()
{
    vwPlayer_SelectVideoOrVis( true );
}


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// vwPlayer_OnOpenStateChange
//
function vwPlayer_OnOpenStateChange(NewState)
{
    vwPlayer_SelectVideoOrVis( false );
}