// Windows Media Player - Copyright 2002 Microsoft Corporation.
//<script>

var g_StartTime = 0.0;
var g_EndTime = 0.0;

//
// Initialization
//

function InitMediaLink()
{
    var bEnabled = false;

    if (osMediaOpen == player.openState)
    {
        g_StartTime = 0.0;
        g_EndTime = player.currentMedia.duration;

        if (helper.canSendLink)
        {
            markInTime.value = helper.getTimeString(g_StartTime);
            markOutTime.value = helper.getTimeString(g_EndTime);
            bEnabled = true;
        }
    }
    
    warnLocalFile.visible = !bEnabled;

    markInTime.visible = bEnabled;
    markOutTime.visible = bEnabled;
    markIn.enabled = bEnabled;
    markOut.enabled = bEnabled;
    sendLink.enabled = bEnabled;

    // only show play speed controls on XP
    if (helper.isXPOrBetter)
    {
        slow.visible = true;
        normal.visible = true;
        fast.visible = true;
        stepgroup.visible = true;
    }
    
}

//
// Updating
//

function MarkIn()
{
    g_StartTime = player.controls.currentPosition;
    markInTime.value = helper.getTimeString(g_StartTime);

    if (g_StartTime > g_EndTime)
    {
        g_EndTime = player.currentMedia.duration;
        markOutTime.value = helper.getTimeString(g_EndTime);
    }
}

function MarkOut()
{
    g_EndTime = player.controls.currentPosition;
    markOutTime.value = helper.getTimeString(g_EndTime);

    if (g_EndTime < g_StartTime)
    {
        g_StartTime = 0.0;
        markInTime.value = helper.getTimeString(g_StartTime);
    }
}

function SendLink()
{
    helper.sendLink(g_StartTime, g_EndTime);
}

function GoSlow()
{
    player.settings.rate=mediacenter.slowRate;
}

function GoNormal()
{
    player.settings.rate=1;
}

function GoFast()
{
    player.settings.rate=mediacenter.fastRate;
}
