// Windows Media Player - Copyright 2000 Microsoft Corporation.
//<script>

//
// Initialization
//

function InitSRS()
{
	if (PlayingDVD())
	{
		nextSpeakerSize.enabled=false;
		srsOnOff.enabled=false;
		SetDisabledUI(true);
	}
	else
	{
		srsOnOff.enabled=true;
		UpdateSRSOnOff();
	}
}

//
// Updating
//

function UpdateSRSOnOff()
{
	if (eq.enhancedAudio == true)
	{
		nextSpeakerSize.enabled=true;
		srsOnOff.value="res://wmploc.dll/RT_STRING/#1833";
        srsOnOff.toolTip = "res://wmploc/RT_STRING/#1826";
		SetDisabledUI(false);
	}
	else
	{
		nextSpeakerSize.enabled=false;
		srsOnOff.value="res://wmploc.dll/RT_STRING/#1832";
		srsOnOff.toolTip = "res://wmploc/RT_STRING/#1825";
		SetDisabledUI(true);
	}
}

function NextSpeakerSize()
{
	var index = eq.speakerSize;

	index++;
	if (index > 2)
		index = 0;

	eq.speakerSize = index;
}

function ToggleSRS()
{
    eq.enhancedAudio=!eq.enhancedAudio;
}
